searchData={"items":[{"type":"module","title":"WeightedRandom","doc":"","ref":"WeightedRandom.html"},{"type":"function","title":"WeightedRandom.rand/3","doc":"Returns a random value based on the weights given","ref":"WeightedRandom.html#rand/3"},{"type":"module","title":"WeightedRandom.CubicBezier","doc":"Copied from https://github.com/bjunc/cubic-bezier/tree/master\nUnfortunately the build seems to be broken so I could not use it directly.","ref":"WeightedRandom.CubicBezier.html"},{"type":"function","title":"WeightedRandom.CubicBezier.solve/3","doc":"Given `x` (a float between `0.0` and `1.0`), compute the `y`. \n\nEither an easing atom or control points tuple can be provided.  \nMost common easing equations are support, but if an unsupported atom \nis given, the control points for `:linear` are returned.\n\nSee: https://gist.github.com/terkel/4377409","ref":"WeightedRandom.CubicBezier.html#solve/3"},{"type":"function","title":"Options - WeightedRandom.CubicBezier.solve/3","doc":"- `duration` (integer) - can provide greater accuracy.  \nThe default duration is 400 (ms), which is a common animation / transition duration.","ref":"WeightedRandom.CubicBezier.html#solve/3-options"},{"type":"function","title":"Examples - WeightedRandom.CubicBezier.solve/3","doc":"```elixir\niex> WeightedRandom.CubicBezier.solve(0.50, :ease_out_quad)\n0.7713235628639843\n```\n\n```elixir\niex> WeightedRandom.CubicBezier.solve(0.5, {0.250,  0.460,  0.450,  0.940})\n0.7713235628639843\n```\n\n```elixir\niex(1)> Enum.map([0.0, 0.25, 0.5, 0.75, 1.0], fn x -> \n...(1)> {x, Float.round(WeightedRandom.CubicBezier.solve(x, :ease_out_quad), 3)}\n...(1)> end)\n[{0.0, 0.0}, {0.25, 0.453}, {0.5, 0.771}, {0.75, 0.936}, {1.0, 1.0}]\n```","ref":"WeightedRandom.CubicBezier.html#solve/3-examples"},{"type":"module","title":"WeightedRandom.Dice","doc":"","ref":"WeightedRandom.Dice.html"},{"type":"function","title":"WeightedRandom.Dice.add_weight/2","doc":"Adds weight to ALL dice in the Dice struct.","ref":"WeightedRandom.Dice.html#add_weight/2"},{"type":"function","title":"Examples - WeightedRandom.Dice.add_weight/2","doc":"iex> :rand.seed(:exsss, {205, 301, 402})\n    iex> d = ~d{10, 20} \n    iex> Enum.map(d.dice, &(&1.result))\n    [17, 10, 1, 16, 17, 15, 11, 16, 12, 3]\n    iex> d.total\n    118\n    iex> d = Dice.add_weight(d, [%{target: 2, weight: 25}])\n    iex> d = Dice.roll(d)\n    iex> Enum.map(d.dice, &(&1.result))\n    [2, 2, 2, 2, 3, 2, 2, 2, 18, 6]\n    iex> d.total\n    41","ref":"WeightedRandom.Dice.html#add_weight/2-examples"},{"type":"function","title":"WeightedRandom.Dice.merge_dice/1","doc":"Take a list of Dice structs, and combine them without rerolling","ref":"WeightedRandom.Dice.html#merge_dice/1"},{"type":"function","title":"WeightedRandom.Dice.merge_dice/2","doc":"","ref":"WeightedRandom.Dice.html#merge_dice/2"},{"type":"function","title":"WeightedRandom.Dice.new/1","doc":"Directly create a Dice struct.","ref":"WeightedRandom.Dice.html#new/1"},{"type":"function","title":"WeightedRandom.Dice.roll/1","doc":"Takes a Dice struct and rerolls it.","ref":"WeightedRandom.Dice.html#roll/1"},{"type":"function","title":"Examples - WeightedRandom.Dice.roll/1","doc":"iex> :rand.seed(:exsss, {200, 301, 402})\n    iex> dice = ~d{2, 12}\n    iex> dice.total\n    8\n    iex> Dice.roll(dice).total\n    16","ref":"WeightedRandom.Dice.html#roll/1-examples"},{"type":"function","title":"WeightedRandom.Dice.sigil_d/2","doc":"Convenience sigil for creating dice","ref":"WeightedRandom.Dice.html#sigil_d/2"},{"type":"function","title":"Examples - WeightedRandom.Dice.sigil_d/2","doc":"iex> :rand.seed(:exsss, {100, 101, 102})\n    iex> d = ~d{4, 6, 1} # Equal to 4d6+1 in standard dice notation\n    iex> [die1 | _] = d.dice\n    iex> die1\n    %WeightedRandom.Die{sides: 6, weights: [], result: 2}\n    iex> d.subtotal\n    10\n    iex> d.total\n    11","ref":"WeightedRandom.Dice.html#sigil_d/2-examples"},{"type":"extras","title":"weighted_random","doc":"","ref":"weighted_random.html"},{"type":"extras","title":"Weighted Random Guide - weighted_random","doc":"Sometimes random is *too* random. Use this to add a bias toward a certain value (or values)\nAlso supports such values impacting their neighbours\n\nNot intended to be cryptographically secure.\nAlso not nearly as performant as a simple Enum.random/1, so consider whether you actually need this.\n\nTakes a list or range of values, and another list of weights.\n\nEvery value in the range automatically gets a weight of 1.\nWhen you pass in `%{target: 25, weight: 2}` this is actually ADDING 2 to the total number of 'votes' that 25 gets.\n\nAnd when you add a radius: Now the surrounding values also get a boost.\n\nAs an example: `%{target: 10, weight: 10, radius: 3}`\n\n- there are 3 extra votes for 8\n- there are 7 extra votes for 9\n- There are 10 extra votes for 10\n- there are 7 extra votes for 11\n- there are 3 extra votes for 12\n\n(Yes the numbers are rounded)\n\nAnd this is only using a linear curve. You could also pass in something like:\n\n`%{target: 10, weight: 10, radius: 3, curve: :ease_out}`\n\nWhich will change how much of a boost goes to the surrounding values caught in the radius.","ref":"weighted_random.html#weighted-random-guide"},{"type":"extras","title":"Allowed Curve Types - weighted_random","doc":"```elixir\n:linear (default)\n:ease\n:ease_in\n:ease_out\n:ease_in_out\n:ease_in_quad\n:ease_in_cubic\n:ease_in_quart\n:ease_in_quint\n:ease_in_sine\n:ease_in_expo\n:ease_in_circ\n:ease_in_back\n:ease_out_quad\n:ease_out_cubic\n:ease_out_quart\n:ease_out_quint\n:ease_out_sine\n:ease_out_expo\n:ease_out_circ\n:ease_out_back\n:ease_in_out_quad\n:ease_in_out_cubic\n:ease_in_out_quart\n:ease_in_out_quint\n:ease_in_out_sine\n:ease_in_out_expo\n:ease_in_out_circ\n:ease_in_out_back\n```","ref":"weighted_random.html#allowed-curve-types"},{"type":"extras","title":"Examples - weighted_random","doc":"iex> # You won't need this. It's only necessary for consistent test results.\n    iex> :rand.seed(:exsss, {100, 101, 102})\n    iex>\n    iex>\n    iex> range = 1..10\n    iex> weight = %{target: 2, weight: 10}\n    iex> Stream.repeatedly(fn -> rand(range, weight, index: false) end) |> Enum.take(10)\n    [4, 2, 2, 4, 4, 2, 2, 9, 10, 2]\n    iex>\n    iex> # As you can see, 2 is 10x more likely to appear than any other given number.\n    iex> # But what if we take away the `index: false` option?\n    iex> Stream.repeatedly(fn -> rand(range, weight) end) |> Enum.take(10)\n    [7, 3, 3, 7, 3, 3, 1, 7, 3, 8]\n    iex>\n    iex> # Notice that it was biasing toward the INDEX of 2, not the value of 2.\n    iex> # This is useful later when we are not simply using integers.\n    iex>\n    iex> # Let's play with a radius!\n    iex> range = 1..50\n    iex> weights = [%{target: 25, weight: 20, radius: 5}]\n    iex> # Here, the radius of 5 means that extra weight is ALSO given to the 5 values on either side of 25. I.e.: 20..24 and 26..30\n    iex> Stream.repeatedly(fn -> rand(range, weights, index: false) end) |> Enum.take(10)\n    [29, 35, 27, 23, 25, 23, 24, 17, 23, 27]\n    iex>\n    iex> # Wow, 8 out of 10 values fall within that radius!\n    iex> # And remember, you can pass the :curve option to adjust how the weight is spread out to neighbours.\n    iex>\n    iex> # We are not limited to integers\n    iex> # (Remember it is based off index)\n    iex> range = [true, false, nil, \"Apples\", :boat]\n    iex> weights = [%{target: 0, weight: 100}]\n    iex> Stream.repeatedly(fn -> rand(range, weights) end) |> Enum.take(3)\n    [true, true, true]\n    iex>\n    iex>","ref":"weighted_random.html#examples"},{"type":"extras","title":"Finally, there is no limit to how many weights you can use. - weighted_random","doc":"iex> range = 1..10\n    iex> weight1 = %{target: 7, weight: 15, radius: 4, curve: :ease_in_sine}\n    iex> weight2 = %{target: 1, weight: 35}\n    iex> weights = [weight1, weight2]\n    iex> Stream.repeatedly(fn -> rand(range, weights, index: false) end) |> Enum.take(10)\n    [8, 1, 1, 5, 8, 6, 7, 7, 1, 10]","ref":"weighted_random.html#finally-there-is-no-limit-to-how-many-weights-you-can-use"},{"type":"extras","title":"dice","doc":"","ref":"dice.html"},{"type":"extras","title":"Dice Guide - dice","doc":"This allows us to use dice in creative ways (weighted dice are optional).\nThe ~d sigil can be used to generate dice in a way fairly similar to the standard dice notation used by many tabletop roleplaying games.\nBut instead of \"2d12+1\", you would write `~d{2, 12, 1}`","ref":"dice.html#dice-guide"},{"type":"extras","title":"Examples - dice","doc":"iex> :rand.seed(:exsss, {100, 101, 102})\n    iex> alias WeightedRandom.Dice\n    iex> import Dice\n    iex> d = ~d{4, 6, 1} # Equal to 4d6+1 in standard dice notation\n    iex> [die1 | _] = d.dice\n    iex> die1\n    %WeightedRandom.Die{sides: 6, weights: [], result: 2}\n    iex> d.subtotal\n    10\n    iex> d.total\n    11\n\nThis is different from simply calling Enum.random/1, because it creates a persistent Dice struct which contains a :dice list. Each die in the list is a persistent Die struct, that has a specific number of sides and weights.\n\nSo you would first define the dice, their various options, and then continue calling Dice.roll(dice) as many times as you need.\nThe final value that you are looking for is under :total.\n\nExamples\n\n```elixir\n    iex> :rand.seed(:exsss, {205, 301, 402})\n    iex> d = ~d{10, 20} \n    iex> Enum.map(d.dice, &(&1.result))\n    [17, 10, 1, 16, 17, 15, 11, 16, 12, 3]\n    iex> d.total\n    118\n    iex> d = Dice.add_weight(d, [%{target: 2, weight: 25}])\n    iex> d = Dice.roll(d)\n    iex> Enum.map(d.dice, &(&1.result))\n    [2, 2, 2, 2, 3, 2, 2, 2, 18, 6]\n    iex> d.total\n    41\n```","ref":"dice.html#examples"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}